package dev.fyloz.trial.colorrecipesexplorer.core.model;

import lombok.*;
import org.hibernate.annotations.ColumnDefault;

import javax.persistence.*;
import javax.validation.constraints.NotNull;
import java.util.List;

@Entity
@Data
@EqualsAndHashCode(callSuper = false)
@RequiredArgsConstructor
@NoArgsConstructor
public class MaterialType implements IModel {

    public static final MaterialType DEFAULT_MATERIAL_TYPE;
    public static final MaterialType BASE_MATERIAL_TYPE;

    static {
        DEFAULT_MATERIAL_TYPE = new MaterialType("Aucun", "", false);
        BASE_MATERIAL_TYPE = new MaterialType("Base", "BAS", false);
    }

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    private Long id;

    @NonNull
    @NotNull
    @Column(unique = true)
    private String name;

    @NonNull
    @NotNull
    @Column(unique = true)
    private String prefix;

    @NonNull
    @NotNull
    @ColumnDefault("false")
    private Boolean usePercentages;
}
