package dev.fyloz.trial.colorrecipesexplorer.dao;

import dev.fyloz.trial.colorrecipesexplorer.core.model.Material;
import dev.fyloz.trial.colorrecipesexplorer.core.model.MaterialType;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface MaterialDao extends JpaRepository<Material, Long> {
    Optional<Material> findByName(String name);

    List<Material> findAllByMaterialType(MaterialType materialType);

    List<Material> findAllByNameContainingIgnoreCase(String stringSearch);

    boolean existsByName(String name);
}
